/***********************************************************************/

#ifndef CLI_H
#define CLI_H

 #include "usart_comm.h"

/*****************************/
/* FOR AVRGCC 4.33 or higher */
/*****************************/

#define CLI_PCMD_Baudrate      'B'
#define CLI_PCMD_S_Trackswitch 'T'
#define CLI_PCMD_S_Decoupler   'D'
#define CLI_PCMD_S_PowerSource 'V'
#define CLI_PCMD_S_Signal      'S'
#define CLI_PCMD_S_Posdetect   'O'
#define CLI_PCMD_S_Light       'A'
#define CLI_PCMD_S_Loco        'L'
#define CLI_PCMD_S_PowerDist   'P'
#define CLI_PCMD_S_Servo       'E'
#define CLI_PCMD_S_NewI2CAdress 'X'
#define CLI_PCMD_S_DirectData  'Y'


#define CLI_PCMD_Trackswitch 't'
#define CLI_PCMD_Decoupler   'd'
#define CLI_PCMD_PowerSource 'v'
#define CLI_PCMD_Signal      's'
#define CLI_PCMD_Posdetect   'o'
#define CLI_PCMD_Light       'a'
#define CLI_PCMD_Loco        'l'
#define CLI_PCMD_PowerDist   'p'
#define CLI_PCMD_Servo       'e'

#define CLI_PCMD_SCAN0       '0'
#define CLI_PCMD_SCAN1       '1'
#define CLI_PCMD_SCAN2       '2'


#define CLI_Param_BaudrateM_115k    11
#define CLI_Param_BaudrateL_115k    52
#define CLI_Param_BaudrateM_19k2    1
#define CLI_Param_BaudrateL_19k2    92


struct DeviceInfoBlock
{
 unsigned int  RS485adress;          
 unsigned char SUBadress;          
 unsigned char SUBportbit;
 
 unsigned int  SUBnum;          // Subnumber for Servo and  pos detectors
 
 unsigned int  LocoAdress;
 unsigned char LocoConfig;
 unsigned char STRING[56];        

 unsigned int  DeviceNum;
 unsigned int  EEPAdress;

};
/****************************************************************/
/* variables */
/****************************************************************/

volatile struct DeviceInfoBlock GlobalDIB;
/****************************************************************/
/* functions */
/****************************************************************/
/* Layer 3 */
void CLI_PacketHandler(unsigned char *TxBuffer);
void CLI_ReadHandler(unsigned char *TxBuffer);
void CLI_WriteHandler(unsigned char *TxBuffer);
void CLI_MultiWriteHandler(unsigned char *TxBuffer);
void CLI_MultiReadHandler(unsigned char *TxBuffer);
void CLI_SETHandler(unsigned char *TxBuffer);
void CLI_GETHandler(unsigned char *TxBuffer);
void CLI_CLRHandler(unsigned char *TxBuffer);
void CLI_SCANHandler(unsigned char *TxBuffer);
void CLI_SEARCHHandler(unsigned char *TxBuffer);
unsigned char CLI_DirectData(unsigned char *TxBuffer);

void CLI_CopyDIBstr2PIBstr(void);
void CLI_CopyPIBstr2DIBstr(void);
unsigned int CLI_BUS485_Specialadresses(void);
unsigned char IsBitSETinVar_uchar(unsigned char Var, unsigned char Bitnum);
unsigned char CLRBITinVar_uchar(unsigned char Var, unsigned char Bitnum);
unsigned char SETBITinVar_uchar(unsigned char Var, unsigned char Bitnum);

void CLI_GET485_DeviceInfo(void);

/* Layer 4 */
void CLI_SetBaudrate(unsigned char *TxBuffer);
unsigned char CLI_SetNewI2CAdresson485(unsigned char *TxBuffer);


/**************************************************************/
/*

*/

#endif

/*
Doku:
T,A,D,I:    EEE=RS485Adress, FF=I2C-SUB, GG=I2C-Port/Bit





*/

