#include "COMM485.h"
#include "usart_driver.h"
#include "SysTimer.h"
#include "devices.h"
/*************************************************************************/
/*                  */
/*************************************************************************/
unsigned char BUS485_WriteData_Packet(unsigned int Adress, unsigned char *TxBuf,unsigned int Txbuflen,unsigned int CMD, unsigned char Param1, unsigned char Param2)
{

 unsigned int  ChecksumI;
 unsigned int  cnt;
 
 Txbuflen+=11;	// add header to len
 
 USART_BUS485_ModeTx();
 USART_RS485_Buf[0]=Adress >> 8;
 USART_RS485_Buf[1]=Adress & 0xFF;
 USART_RS485_Buf[2]=BUS485_CONFIG_WRITE+BUS485_CONFIG_CHKSUM; // Set Write and Checksum Mode                
 USART_RS485_Buf[3]=Txbuflen >> 8;
 USART_RS485_Buf[4]=Txbuflen & 0xFF;
 USART_RS485_Buf[5]=CMD >> 8;
 USART_RS485_Buf[6]=CMD & 0xFF;
 USART_RS485_Buf[7]=Param1;
 USART_RS485_Buf[8]=Param2;

 
 //*** BREAK ***//
 USART_BUS485_BREAK();
 
 //*** Send Header ***//
 ChecksumI=0;
 for (cnt=0;cnt<9;cnt++)
 {
    USART_BUS485_TxByte(USART_RS485_Buf[cnt]);
    ChecksumI+=USART_RS485_Buf[cnt];
 } 

 
 //*** SEND Payload(buffer) ***//
 Txbuflen-=11;
 if (Txbuflen)
 {
    for (cnt=0;cnt<Txbuflen;cnt++)
    {
        USART_BUS485_TxByte(*(TxBuf));          // send byte
        ChecksumI+=*(TxBuf++);                  // calc checksum
    } 
 }
 
 
 //*** Send Checksum ***//
 USART_BUS485_TxByte(ChecksumI >> 8);
 USART_BUS485_TxByte(ChecksumI & 0xFF);
 USART_BUS485_WaitTxByteDone();
 
 //USART_BUS485_WaitTxByteDone();
 
 //*** Wait 4 SYNC ***// 
 USART_BUS485_ResetRX();    
 USART_BUS485_ModeRx();
 cnt=BUS485_Waitforchar(USART_485_SyncDataWriteTimeout);
 
 /* Timeout ? */
 if (cnt==BUS485_Error_TimeoutSync)   return(BUS485_Error_TimeoutSync);

 /* Data ? */
 return(USART_RS485_Buf[0]);             // -> Exit
}  


/*************************************************************************/
/*                  */
/*************************************************************************/
unsigned char BUS485_PING(unsigned int Adress)
{

 unsigned int  ChecksumI;
 unsigned int  cnt;
 
 USART_BUS485_ModeTx();
 USART_RS485_Buf[0]=Adress >> 8;
 USART_RS485_Buf[1]=Adress & 0xFF;
 USART_RS485_Buf[2]=BUS485_CONFIG_WRITE+BUS485_CONFIG_CHKSUM; // Set Write and Checksum Mode                
 USART_RS485_Buf[3]=0;
 USART_RS485_Buf[4]=11;
 USART_RS485_Buf[5]=0;
 USART_RS485_Buf[6]=0;
 USART_RS485_Buf[7]=0;
 USART_RS485_Buf[8]=0;

 
 //*** BREAK ***//
 USART_BUS485_BREAK();
 
 //*** Send Header ***//
 ChecksumI=0;
 for (cnt=0;cnt<9;cnt++)
 {
    USART_BUS485_TxByte(USART_RS485_Buf[cnt]);
    ChecksumI+=USART_RS485_Buf[cnt];
 } 

  
 //*** Send Checksum ***//
 USART_BUS485_TxByte(ChecksumI >> 8);
 USART_BUS485_TxByte(ChecksumI & 0xFF);
 USART_BUS485_WaitTxByteDone();
 
 
 //*** Wait 4 SYNC ***// 
 USART_BUS485_ResetRX();    
 USART_BUS485_ModeRx();
 cnt=BUS485_Waitforchar(USART_485_SyncPingTimeout);
 
 /* Timeout ? */
 if (cnt==BUS485_Error_TimeoutSync)   return(BUS485_Error_TimeoutSync);

 /* Data ? */
 return(USART_RS485_Buf[0]);             // -> Exit
}  

/*************************************************************************/
/*                  */
/*************************************************************************/
unsigned char BUS485_ReadData_Packet(unsigned int Adress, unsigned char *RxBuf,unsigned int CMD, unsigned char Param1, unsigned char Param2)
{

 unsigned int  ChecksumI;
 unsigned int  cnt;
 unsigned int  Rxlen;
 unsigned char status;
 
 USART_BUS485_ModeTx();
 USART_RS485_Buf[0]=Adress >> 8;
 USART_RS485_Buf[1]=Adress & 0xFF;
 USART_RS485_Buf[2]=BUS485_CONFIG_READ+BUS485_CONFIG_CHKSUM;                  // CONFIG !!!!!
 USART_RS485_Buf[3]=0;
 USART_RS485_Buf[4]=11;
 USART_RS485_Buf[5]=CMD >> 8;
 USART_RS485_Buf[6]=CMD & 0xFF;
 USART_RS485_Buf[7]=Param1;
 USART_RS485_Buf[8]=Param2;
 
 //*** BREAK ***//
 USART_BUS485_BREAK();
 
 //*** Send Header ***//
 ChecksumI=0;
 for (cnt=0;cnt<9;cnt++)
 {
    USART_BUS485_TxByte(USART_RS485_Buf[cnt]);
    ChecksumI+=USART_RS485_Buf[cnt];
 } 

 USART_BUS485_TxByte(ChecksumI >> 8);
 USART_BUS485_TxByte(ChecksumI & 0xFF);
 USART_BUS485_WaitTxByteDone();
 
 //*** Wait 4 SYNC or Data ***// 
 USART_BUS485_ResetRX();   
 USART_BUS485_ModeRx();
 status=BUS485_Waitforchar(USART_485_SyncDataReadTimeout);
 
 /* Timeout ? */
 if (status==BUS485_Error_TimeoutSync)   return(BUS485_Error_TimeoutSync);

 /* No Timeout -> SYNC */
 if ((USART_RS485_Buf[0] != BUS485_Error_None) || (USART_RS485_Buf[0] != BUS485_Device_ACK))
 {
 //	return(USART_RS485_Buf[0]);		// something wrong -> exit
 }

 /* LEN MSB */
 status=BUS485_Waitforchar(USART_485_ByteReadTimeout);
 //if (status==BUS485_Error_TimeoutSync)   return(BUS485_Error_TimeoutByte);
 Rxlen=USART_RS485_Buf[1];
 Rxlen=Rxlen << 8;
 
 /* LEN LSB */
 status=BUS485_Waitforchar(USART_485_ByteReadTimeout);
// if (status==BUS485_Error_TimeoutSync)   return(BUS485_Error_TimeoutByte);
 Rxlen+=USART_RS485_Buf[2];
 
 /* Receive Data */ 
 cnt=2;
 while (cnt < (Rxlen))
 {
 	 status=BUS485_Waitforchar(USART_485_ByteReadTimeout);
 	 if (status==BUS485_Error_TimeoutSync)   
      {
       return(BUS485_Error_TimeoutByte);
      } 
     cnt++;
 }
 
 /* Checksum */
 ChecksumI=0;
 for (cnt=1;cnt<(Rxlen-1);cnt++)
 {
    ChecksumI+=USART_RS485_Buf[cnt];
 }	 
 if ((((ChecksumI >> 8 ) & 0xFF) !=USART_RS485_Buf[Rxlen-1]) || ((ChecksumI & 0xFF) !=USART_RS485_Buf[Rxlen]))
 {
 	return(BUS485_Device_ERR_CHK);
 }
 
 /* DataCopy */
 for (cnt=3;cnt<(Rxlen-1);cnt++)
 {
  	*(RxBuf++)=USART_RS485_Buf[cnt];
 }	
 
 
 return(BUS485_Device_ACK);
}  

/**************************************************************************/
/**** Wait for char                                                     ***/
/**************************************************************************/
unsigned char BUS485_Waitforchar(unsigned int Timeout)
{
    
	// Wait Timeout time for char
	// Timeout is in 50s steps
	unsigned char t;
    
    t=0;
    USART_485_Timeout=Timeout;
    while(!t)
    {
        if (!USART_485_Timeout)    return(BUS485_Error_TimeoutSync);    // exit loop, timeout
        if (USART_485_Status & USART_STATUS_RX_NewChr)
		{		
				USART_485_Status&=~USART_STATUS_RX_NewChr;  // CLR FLAG
		        return(BUS485_Device_ACK);           		// exit loop, sync received
		}            
    }
    return(BUS485_Device_ACK);
}       
