#ifndef COMM485_H
#define COMM485_H

#define COMM485_CMD_GETINFO  0x0101


/********* Timing **************/
// timeout tick is 50s
#define USART_485_SyncPingTimeout  		3
#define USART_485_SyncDataWriteTimeout  5000
#define USART_485_SyncDataReadTimeout 	150
#define USART_485_ByteReadTimeout 		5

// timeout tick 10ms
#define USART_485_Busytimeout  100

/********* Control **************/
#define BUS485_CONFIG_WRITE		(1<<7)
#define BUS485_CONFIG_READ		(0<<7)
#define BUS485_CONFIG_CHKSUM	(1<<0)
#define BUS485_CONFIG_CRC		(0<<0)


/********* Errors **************/

#define BUS485_Error_None        0x00
#define BUS485_Error_TimeoutSync 0xB0
#define BUS485_Error_TimeoutByte 0xB1

#define BUS485_Device_INPROG 	 0x10 	
#define BUS485_Device_ACKDone 	 0x00
#define BUS485_Device_ACK 	     0x80
#define BUS485_Device_STRETCH 	 0x55
#define BUS485_Device_ERR_CHK 	 0x81
#define BUS485_Device_ERR_CMD 	 0x82
#define BUS485_Device_ERR_LEN 	 0x83 
#define BUS485_Device_BUSY 	     0x90 	

/********* functions **************/
unsigned char BUS485_PING(unsigned int Adress);
unsigned char BUS485_WriteData_Packet(unsigned int Adress, unsigned char *TxBuf,unsigned int Txbuflen,unsigned int CMD, unsigned char Param1, unsigned char Param2);
unsigned char BUS485_Waitforchar(unsigned int Timeout);	
unsigned char BUS485_ReadData_Packet(unsigned int Adress, unsigned char *RxBuf,unsigned int CMD, unsigned char Param1, unsigned char Param2);
#endif
