
#include "TWI_M_P.h"
#include "EEP_24FC1025.h"
#include "SysTimer.h"


/**********************************************************************/
/***                                                                 */
/**********************************************************************/
unsigned char EEP_24FC1025_ReadPage(unsigned long Adress,unsigned char *data)
{
 unsigned char EEP_24FC1025[10];
 unsigned char tr;
 unsigned int  BADR;
 unsigned char I2CADR;
  
 EEP_24FC1025_MapAdress_2_I2CADR_BADR(Adress,&I2CADR,&BADR);

 EEP_24FC1025[0]=(BADR >> 8) & 0xFF;
 EEP_24FC1025[1]=(BADR >> 0) & 0xFF;

 tr=TWI_MasterWriteRead(EEP241025_TWI,
		                    I2CADR,
		                    &EEP_24FC1025[0],
		                    data,
		                    2,
		                    EEP_24FC1025_PageSize);
     
 if (tr == TWIDRV_Status_NACK) return(TWIDRV_Status_NACK);
 return(EEP_24FC1025_Error_NONE); 		
		
}
/**********************************************************************/
/*** */
/**********************************************************************/
unsigned char EEP_24FC1025_WritePage(unsigned int Adress,unsigned char *data)
{
 unsigned char EEP_24FC1025[265];
 unsigned char cnt;
 unsigned char ACK;
 unsigned int  BADR;
 unsigned char I2CADR;
  
 EEP_24FC1025_MapAdress_2_I2CADR_BADR(Adress,&I2CADR,&BADR);
 
 EEP_24FC1025[0]=(BADR >> 8) & 0xFF;
 EEP_24FC1025[1]=(BADR >> 0) & 0xFF;

 for (cnt=0;cnt<EEP_24FC1025_PageSize;cnt++)  EEP_24FC1025[cnt+2]=*(data+cnt); 

 ACK=TWI_MasterWriteRead(EEP241025_TWI,
		                    I2CADR,
		                    &EEP_24FC1025[0],
		                    &EEP_24FC1025[265],
		                    EEP_24FC1025_PageSize+2,
		                    0);
return(ACK);
	
}
/**********************************************************************/
/*** Init                                                             */ 
/**********************************************************************/
unsigned char EEP_24FC1025_Init(void)
{
 
 unsigned char Devices;
 Devices=0;
 unsigned char t;
 
 TWI_MasterInit(EEP241025_TWI,cnst_TWI_Baudrate_1M);

 t= TWI_Master_CheckDeviceACK(EEP241025_TWI,EEP_24FC1025_ADR_0);
 if (t==EEP_24FC1025_Error_NONE) Devices++;

 return(Devices);
}
/**********************************************************************/
/*** */
/**********************************************************************/
// only for EEP #0 !
unsigned char EEP_24FC1025_ReadByte(unsigned int Adress,unsigned char *data)
{
 unsigned char EEP_24FC1025[10];
 unsigned char tr;
 unsigned int  BADR;
 unsigned char I2CADR;
  
 EEP_24FC1025_MapAdress_2_I2CADR_BADR(Adress,&I2CADR,&BADR);
 
 EEP_24FC1025[0]=(BADR >> 8) & 0xFF;
 EEP_24FC1025[1]=(BADR >> 0) & 0xFF;

 tr=TWI_MasterWriteRead(EEP241025_TWI,
		                    I2CADR,
		                    &EEP_24FC1025[0],
		                    &EEP_24FC1025[8],
		                    2,
		                    1);

     
 *data=EEP_24FC1025[8];
 if (tr == TWIDRV_Status_NACK) return(TWIDRV_Status_NACK);
 return(EEP_24FC1025_Error_NONE); 		
		
}
/**********************************************************************/
/*** */
/**********************************************************************/
unsigned char EEP_24FC1025_ReadMultiByte(unsigned int Adress,unsigned char *data, unsigned char Len)
{
 unsigned char EEP_24FC1025[10];
 unsigned char tr;
 unsigned int  BADR;
 unsigned char I2CADR;
  
 EEP_24FC1025_MapAdress_2_I2CADR_BADR(Adress,&I2CADR,&BADR);
 
 EEP_24FC1025[0]=(BADR >> 8) & 0xFF;
 EEP_24FC1025[1]=(BADR >> 0) & 0xFF;

 tr=TWI_MasterWriteRead(EEP241025_TWI,
		                    I2CADR,
		                    &EEP_24FC1025[0],
		                    data,
		                    2,
		                    Len);

     
 if (tr == TWIDRV_Status_NACK) return(TWIDRV_Status_NACK);
 return(EEP_24FC1025_Error_NONE); 		
}
/**********************************************************************/
/*** */
/**********************************************************************/
// only for EEP #0 !
unsigned char EEP_24FC1025_WriteByte(unsigned int Adress,unsigned char data)
{
 unsigned char EEP_24FC1025[10];
 unsigned char tr;
 unsigned int  BADR;
 unsigned char I2CADR;
  
 EEP_24FC1025_MapAdress_2_I2CADR_BADR(Adress,&I2CADR,&BADR);
 
 EEP_24FC1025[0]=(BADR >> 8) & 0xFF;
 EEP_24FC1025[1]=(BADR >> 0) & 0xFF;
 EEP_24FC1025[2]=data;
 tr=TWI_MasterWriteRead(EEP241025_TWI,
		                    I2CADR,
		                    &EEP_24FC1025[0],
		                    &EEP_24FC1025[2],
		                    3,
		                    0);


  return(EEP_24FC1025_CheckBusy(EEP_24FC1025_ADR_0));
}
/**********************************************************************/
/****/ 
/**********************************************************************/
unsigned char EEP_24FC1025_CheckBusy(unsigned char EEP_Adress)
{
unsigned int NACK;
unsigned char tr;

unsigned int  BADR;
unsigned char I2CADR;
  
EEP_24FC1025_MapAdress_2_I2CADR_BADR(EEP_Adress,&I2CADR,&BADR);

// 24FC512 spec is 5ms per byte/page write
// TWI is 1MBit -> 30 s per dataword 
NACK=888;

while((NACK) && (NACK<0xFFFF))
{

 tr= TWI_Master_CheckDeviceACK(EEP241025_TWI,I2CADR);
 while (tr == TWIDRV_Status_BUSY)                  // Read status while TWI is busy
     {
       		 tr= TWI_Master_CheckDeviceACK(EEP241025_TWI,I2CADR);
     }
 if (tr == TWIDRV_Status_NACK)
 {
  NACK--;
 }
 else
 {
  NACK=0xFFFF;
 } 

}

  if (!(NACK)) return(EEP_24FC1025_Error_NACK);      // not ACK -> Error
  return(EEP_24FC1025_Error_NONE);                   // No Error
}
/**********************************************************************/
/***  */
/**********************************************************************/
void EEP_24FC1025_MapAdress_2_I2CADR_BADR(unsigned long Adress, unsigned char *I2CADR,unsigned int *BADR)
{
    // I2CADR = Adress of I2C Block
    // BADR   = Byte Adress in Block
    
    if (Adress > 0xFFFF)
    {
        *I2CADR=EEP_24FC1025_ADR_1;
        *BADR=Adress & 0xFFFF;
    }
    else
    {
        *I2CADR=EEP_24FC1025_ADR_0;
        *BADR=Adress & 0xFFFF;
    }
}
