
#include "TWI_M_P.h"
#include "EEP_24FC512.h"
#include "SysTimer.h"


/**********************************************************************/
/***                                                                 */
/**********************************************************************/
unsigned char EEP_24FC512_ReadPage(unsigned int Adress,unsigned char *data)
{
unsigned char EEP_24FC512[10];
unsigned char tr;

EEP_24FC512[0]=(Adress >> 8) & 0xFF;
EEP_24FC512[1]=(Adress >> 0) & 0xFF;

tr=TWI_MasterWriteRead(EEP24256_TWI,
		                    EEP_24FC512_ADR_0,
		                    &EEP_24FC512[0],
		                    data,
		                    2,
		                    EEP_24FC512_PageSize);
     
 if (tr == TWIDRV_Status_NACK) return(TWIDRV_Status_NACK);
 return(EEP_24FC512_Error_NONE); 		
		
}
/**********************************************************************/
/*** */
/**********************************************************************/
unsigned char EEP_24FC512_WritePage(unsigned int Adress,unsigned char *data)
{
unsigned char EEP_24FC512[265];
unsigned char cnt;
unsigned char ACK;


EEP_24FC512[0]=(Adress >> 8) & 0xFF;
EEP_24FC512[1]=(Adress >> 0) & 0xFF;

for (cnt=0;cnt<EEP_24FC512_PageSize;cnt++)  EEP_24FC512[cnt+2]=*(data+cnt); 

ACK=TWI_MasterWriteRead(EEP24256_TWI,
		                    EEP_24FC512_ADR_0,
		                    &EEP_24FC512[0],
		                    &EEP_24FC512[265],
		                    EEP_24FC512_PageSize+2,
		                    0);
return(ACK);
	
}






/**********************************************************************/
/*** Init                                                             */ 
/**********************************************************************/
unsigned char EEP_24FC512_Init(void)
{
 
 unsigned char Devices;
 Devices=0;
 unsigned char t;
 
 TWI_MasterInit(EEP24256_TWI,cnst_TWI_Baudrate_1M);

 t= TWI_Master_CheckDeviceACK(EEP24256_TWI,EEP_24FC512_ADR_0);
 if (t==EEP_24FC512_Error_NONE) Devices++;

 return(Devices);
}


/**********************************************************************/
/*** */
/**********************************************************************/
// only for EEP #0 !
unsigned char EEP_24FC512_ReadByte(unsigned int Adress,unsigned char *data)
{
unsigned char EEP_24FC512[10];
unsigned char tr;

EEP_24FC512[0]=(Adress >> 8) & 0xFF;
EEP_24FC512[1]=(Adress >> 0) & 0xFF;

tr=TWI_MasterWriteRead(EEP24256_TWI,
		                    EEP_24FC512_ADR_0,
		                    &EEP_24FC512[0],
		                    &EEP_24FC512[8],
		                    2,
		                    1);

     
 *data=EEP_24FC512[8];
 if (tr == TWIDRV_Status_NACK) return(TWIDRV_Status_NACK);
 return(EEP_24FC512_Error_NONE); 		
		
}
/**********************************************************************/
/*** */
/**********************************************************************/
unsigned char EEP_24FC512_ReadMultiByte(unsigned int Adress,unsigned char *data, unsigned char Len)
{
unsigned char EEP_24FC512[10];
unsigned char tr;

EEP_24FC512[0]=(Adress >> 8) & 0xFF;
EEP_24FC512[1]=(Adress >> 0) & 0xFF;

tr=TWI_MasterWriteRead(EEP24256_TWI,
		                    EEP_24FC512_ADR_0,
		                    &EEP_24FC512[0],
		                    data,
		                    2,
		                    Len);

     
 if (tr == TWIDRV_Status_NACK) return(TWIDRV_Status_NACK);
 return(EEP_24FC512_Error_NONE); 		
}



/**********************************************************************/
/*** */
/**********************************************************************/
// only for EEP #0 !
unsigned char EEP_24FC512_WriteByte(unsigned int Adress,unsigned char data)
{
unsigned char EEP_24FC512[10];
EEP_24FC512[0]=(Adress >> 8) & 0xFF;
EEP_24FC512[1]=(Adress >> 0) & 0xFF;
EEP_24FC512[2]=data;
TWI_MasterWriteRead(EEP24256_TWI,
		                    EEP_24FC512_ADR_0,
		                    &EEP_24FC512[0],
		                    &EEP_24FC512[2],
		                    3,
		                    0);


		return(EEP_24FC512_CheckBusy(EEP_24FC512_ADR_0));
}
/**********************************************************************/
/****/ 
/**********************************************************************/
unsigned char EEP_24FC512_CheckBusy(unsigned char EEP_Adress)
{
unsigned int NACK;
unsigned char tr;

// 24FC512 spec is 5ms per byte/page write
// TWI is 1MBit -> 30 s per dataword 
NACK=888;

while((NACK) && (NACK<0xFFFF))
{

 tr= TWI_Master_CheckDeviceACK(EEP24256_TWI,EEP_Adress);
 while (tr == TWIDRV_Status_BUSY)                  // Read status while TWI is busy
     {
       		 tr= TWI_Master_CheckDeviceACK(EEP24256_TWI,EEP_Adress);
     }
 if (tr == TWIDRV_Status_NACK)
 {
  NACK--;
 }
 else
 {
  NACK=0xFFFF;
 } 

}

  if (!(NACK)) return(EEP_24FC512_Error_NACK);      // not ACK -> Error
  return(EEP_24FC512_Error_NONE);                   // No Error
}

/**********************************************************************/
/***  */
/**********************************************************************/

