
#include "TWI_M_P.h"
#include "EXT_I2C.h"

/**********************************************************************/
/*** Init */ 
/**********************************************************************/
unsigned char EXT_I2C_Init(void)
{
 unsigned char Error;
 Error=0;
 unsigned char Devices;
 Devices=0;
 TWI_MasterInit(EXT_I2C_TWI,cnst_TWI_Baudrate_100k);
 //TWI_MasterInit(EXT_I2C_TWI,cnst_TWI_Baudrate_25k);
 return(Error);	           
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/

/**********************************************************************/
/***  */ 
/**********************************************************************/
unsigned char EXT_I2C_Test_PWMANA_Power(unsigned char Num)
{
	unsigned char buffer[10];
	unsigned char tr;
	unsigned char ADR;
	
	ADR=EXT_I2C_PWMANA_Num2Adress(Num);
	if (ADR==0) return(EXT_I2C_Error_NoDevice);
	
	tr=TWI_MasterWriteRead(EXT_I2C_TWI,
		                    ADR,                   // Adress
		                    &buffer[0],            // Writebuffer
		                    &buffer[0],            // Readbuffer
		                    0,					   // write 0 bytes
		                    3);					   // read  4 bytes	
	if (tr==TWIDRV_Status_NACK) return( EXT_I2C_Error_Deviceunavail);
	if (tr==TWIDRV_Status_Done) return(	 EXT_I2C_Error_NONE);
	return(EXT_I2C_Error_UNKNOWN);	                    
}
/**********************************************************************/
/***  */ 
/**********************************************************************/
unsigned char EXT_I2C_Write_PWMANA_Power(unsigned char Num, unsigned char DTYPE, unsigned char DATA)
{
	unsigned char buffer[10];
	unsigned char tr;
	unsigned char ADR,CHK;
	
	ADR=EXT_I2C_PWMANA_Num2Adress(Num);
	if (ADR==0) return(EXT_I2C_Error_NoDevice);

 	
	buffer[0]=EXT_I2C_PWMANA_FLAG_DataValid;   // Config -> data is valid
	buffer[1]=DTYPE;
	buffer[2]=DATA;
	buffer[3]=EXT_I2C_PWMANA_CHKSUM(ADR,&buffer[0]);// CHKSUM incl. Adress

	tr=TWI_MasterWriteRead(EXT_I2C_TWI,
		                    ADR,                   // Adress
		                    &buffer[0],            // Writebuffer
		                    &buffer[0],            // Readbuffer
		                    4,					   // write 4 bytes
		                    0);					   // read  0 bytes	
	if (tr==TWIDRV_Status_NACK) return(EXT_I2C_Error_Deviceunavail);
    if (tr!=TWIDRV_Status_Done) return(EXT_I2C_Error_UNKNOWN);

	EXT_I2C_Delay10us(100);    // delay 1ms
    
    tr=TWI_MasterWriteRead(EXT_I2C_TWI,
		                    ADR,                   // Adress
		                    &buffer[0],            // Writebuffer
		                    &buffer[0],            // Readbuffer
		                    0,					   // write 0 bytes
		                    4);					   // read  4 bytes
    
    CHK=EXT_I2C_PWMANA_CHKSUM(ADR,&buffer[0]);
	
    if (tr==TWIDRV_Status_NACK) return(EXT_I2C_Error_Deviceunavail);    
    if (CHK != buffer[3])                              return(EXT_I2C_Error_CHKSUM);
    if (!(buffer[0] & EXT_I2C_PWMANA_FLAG_ChecksumOK)) return(EXT_I2C_Error_CHKSUM);
    if (tr==TWIDRV_Status_Done) return(EXT_I2C_Error_NONE);
	return(EXT_I2C_Error_UNKNOWN);	                    
}
/**********************************************************************/
/***  */ 
/**********************************************************************/
unsigned char EXT_I2C_Read_PWMANA_Power(unsigned char Num, unsigned char DTYPE, unsigned char *DATA)
{
	unsigned char buffer[10];
	unsigned char tr;
	unsigned char ADR;
	unsigned char CHK;
	unsigned char retry;
	unsigned char Flag_Err;
	
	
	ADR=EXT_I2C_PWMANA_Num2Adress(Num);
	if (ADR==0) return(EXT_I2C_Error_NoDevice);
 
  //ADR=0x7F;

  retry=3;
	while(retry)
  {
    retry--;
    Flag_Err=0;
    buffer[0]=0;        // Config -> no valid data
    buffer[1]=DTYPE;
	  buffer[2]=*DATA;    // DATA
	  CHK=EXT_I2C_PWMANA_CHKSUM(ADR,&buffer[0]);   // CHKSUM incl. Adress
	  buffer[3]=CHK;
    tr=TWI_MasterWriteRead(EXT_I2C_TWI,
		                    ADR,                   // Adress
		                    &buffer[0],            // Writebuffer
		                    &buffer[0],            // Readbuffer
		                    4,					   // write 3 bytes
		                    0);					   // read  3 bytes	

	  if (tr==TWIDRV_Status_NACK) return(EXT_I2C_Error_Deviceunavail);
    if (tr!=TWIDRV_Status_Done) return(EXT_I2C_Error_UNKNOWN);

	  EXT_I2C_Delay10us(100);    // delay 1ms
    
    
    
    tr=TWI_MasterWriteRead(EXT_I2C_TWI,
		                    ADR,                   // Adress
		                    &buffer[0],            // Writebuffer
		                    &buffer[0],            // Readbuffer
		                    0,					   // write 0 bytes
		                    4);					   // read  4 bytes
    
    CHK=EXT_I2C_PWMANA_CHKSUM(ADR,&buffer[0]);
	
    if (tr==TWIDRV_Status_NACK) return(EXT_I2C_Error_Deviceunavail);    
    if (CHK != buffer[3])  Flag_Err++;
    if (!(buffer[0] & EXT_I2C_PWMANA_FLAG_ChecksumOK)) Flag_Err++;
    
    if (!Flag_Err)  retry=0;
  }
  *(DATA)=buffer[2];
  if (Flag_Err)  return(EXT_I2C_Error_CHKSUM);
  if (tr==TWIDRV_Status_Done) return(EXT_I2C_Error_NONE);
	return(EXT_I2C_Error_UNKNOWN);	                    
     
}
/**********************************************************************/
/***  */ 
/**********************************************************************/
unsigned char  EXT_I2C_PWMANA_Num2Adress(unsigned char num)
{
	switch(num)
	{
        default:                     return(0);break;
        case EXT_I2C_PWMANA_NUM0:    return(EXT_I2C_PWMANA_NUM0_ADR);break;
        case EXT_I2C_PWMANA_NUM1:    return(EXT_I2C_PWMANA_NUM1_ADR);break;
        case EXT_I2C_PWMANA_NUM2:    return(EXT_I2C_PWMANA_NUM2_ADR);break;
        case EXT_I2C_PWMANA_NUM3:    return(EXT_I2C_PWMANA_NUM3_ADR);break;
        case EXT_I2C_PWMANA_NUM4:    return(EXT_I2C_PWMANA_NUM4_ADR);break;
        case EXT_I2C_PWMANA_NUM5:    return(EXT_I2C_PWMANA_NUM5_ADR);break;
        case EXT_I2C_PWMANA_NUM6:    return(EXT_I2C_PWMANA_NUM6_ADR);break;
        case EXT_I2C_PWMANA_NUM7:    return(EXT_I2C_PWMANA_NUM7_ADR);break;
        
    }
	
	return(0);
}
unsigned char EXT_I2C_PWMANA_CHKSUM(unsigned char Adress,unsigned char *buffer)
{
	unsigned char CHK;
	CHK=Adress;
	CHK+=*(buffer);
	CHK+=*(buffer+1);
	CHK+=*(buffer+2);
	return(CHK);
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/

/**********************************************************************/
/***  */ 
/**********************************************************************/
unsigned char EXT_I2C_Init_PCA9555_OUT(unsigned char Adress)
{
	// PWRDIST uses PCA9555(A)
	
	unsigned char buffer[10];
	unsigned char tr;
	
		
	buffer[0]=PCA9555_REG_CFG0;
	buffer[1]=0x00;				// ALL Output		
	buffer[2]=0x00;				// ALL Output
	
	tr=TWI_MasterWriteRead(EXT_I2C_TWI,
		                    Adress,                // Adress
		                    &buffer[0],            // Writebuffer
		                    &buffer[0],            // Readbuffer
		                    3,					   // write 3 bytes
		                    0);					   // read  0 bytes	
	if (tr==TWIDRV_Status_NACK) return( EXT_I2C_Error_Deviceunavail);
	if (tr==TWIDRV_Status_Done) return(	 EXT_I2C_Error_NONE);
	return(EXT_I2C_Error_UNKNOWN);	                    
	
}



/**********************************************************************/
/***  */ 
/**********************************************************************/
unsigned char EXT_I2C_WritePorts_PCA9555(unsigned char Adress, unsigned char port0, unsigned char port1)
{
	// PWRDIST uses PCA9555(A)
	
	unsigned char buffer[10];
	unsigned char tr;
		
	buffer[0]=PCA9555_REG_OUT0;
	buffer[1]=port0;			
	buffer[2]=port1;	
	
	tr=TWI_MasterWriteRead(EXT_I2C_TWI,
		                    Adress,                // Adress
		                    &buffer[0],            // Writebuffer
		                    &buffer[0],            // Readbuffer
		                    3,					   // write 3 bytes
		                    0);					   // read  0 bytes	
	if (tr==TWIDRV_Status_NACK) return( EXT_I2C_Error_Deviceunavail);
	if (tr==TWIDRV_Status_Done) return(	EXT_I2C_Error_NONE);
	return(EXT_I2C_Error_UNKNOWN);	                    
	
}
/**********************************************************************/
/***  */ 
/**********************************************************************/
unsigned char EXT_I2C_ReadPorts_PCA9555(unsigned char Adress, unsigned char *port0, unsigned char *port1)
{
	// PWRDIST uses PCA9555(A)
	
	unsigned char buffer[10];
	unsigned char tr;
		
	buffer[0]= PCA9555_REG_OUT0;
	
	tr=TWI_MasterWriteRead(EXT_I2C_TWI,
		                    Adress,                // Adress
		                    &buffer[0],            // Writebuffer
		                    &buffer[0],            // Readbuffer
		                    1,					   // write 1 bytes
		                    2);					   // read  2 bytes	

	*port0=buffer[0];
	*port1=buffer[1];    			

	if (tr==TWIDRV_Status_NACK) return( EXT_I2C_Error_Deviceunavail);
	if (tr==TWIDRV_Status_Done) return(	EXT_I2C_Error_NONE);
	return(EXT_I2C_Error_UNKNOWN);	                    
	
}  


void EXT_I2C_Delay10us(unsigned int Time2delay)
{
    unsigned int delay10us;
    delay10us=Time2delay;
    while( delay10us)
    {        
        _TWIdelay_loop(105);        // delay 10s
        if (delay10us) delay10us--;
    }    
}     
