#ifndef EXT_I2C_H
#define EXT_I2C_H

#include "TWI_M_P.h"


/*************************************************/


#define EXT_I2C_TWI             1

/*************************************************/
#define EXT_I2C_PWMANA_NUM0 	0
#define EXT_I2C_PWMANA_NUM1 	1
#define EXT_I2C_PWMANA_NUM2 	2
#define EXT_I2C_PWMANA_NUM3 	3
#define EXT_I2C_PWMANA_NUM4 	4
#define EXT_I2C_PWMANA_NUM5 	5
#define EXT_I2C_PWMANA_NUM6 	6
#define EXT_I2C_PWMANA_NUM7 	7

#define EXT_I2C_PWMANA_NUM0_ADR	0x60
#define EXT_I2C_PWMANA_NUM1_ADR	0x61
#define EXT_I2C_PWMANA_NUM2_ADR	0x62
#define EXT_I2C_PWMANA_NUM3_ADR	0x63
#define EXT_I2C_PWMANA_NUM4_ADR	0x64
#define EXT_I2C_PWMANA_NUM5_ADR	0x65
#define EXT_I2C_PWMANA_NUM6_ADR	0x66
#define EXT_I2C_PWMANA_NUM7_ADR	0x67

#define EXT_I2C_PWMANA_FLAG_SLAVEREADY    (1<<7)
#define EXT_I2C_PWMANA_FLAG_ChecksumOK    (1<<2)
#define EXT_I2C_PWMANA_FLAG_NewAdress     (1<<1)
#define EXT_I2C_PWMANA_FLAG_DataValid     (1<<0)
/*************************************************/

#define PCA9555_REG_IN0		0
#define PCA9555_REG_IN1		1
#define PCA9555_REG_OUT0	2
#define PCA9555_REG_OUT1	3
#define PCA9555_REG_POLI0	4		
#define PCA9555_REG_POLI1	5
#define PCA9555_REG_CFG0	6
#define PCA9555_REG_CFG1	7




/*************************************************/

#define EXT_I2C_Error_NONE   0
#define EXT_I2C_Error_NACK   1
#define EXT_I2C_Error_NoDevice  	  0xA1
#define EXT_I2C_Error_Deviceunavail   0xA1
#define EXT_I2C_Error_CHKSUM   		  0xA4
#define EXT_I2C_Error_UNKNOWN 		  0xA3
#define EXT_I2C_Error_PWRDIST_IllegalNum  0xC1


/*************************************************/
/* functions */
unsigned char EXT_I2C_Init(void);
unsigned char EXT_I2C_PWMANA_CHKSUM(unsigned char Adress,unsigned char *buffer);
unsigned char EXT_I2C_Test_PWMANA_Power(unsigned char Num);
unsigned char EXT_I2C_Write_PWMANA_Power(unsigned char Num, unsigned char DTYPE, unsigned char DATA);
unsigned char EXT_I2C_Read_PWMANA_Power(unsigned char Num, unsigned char DTYPE, unsigned char *DATA);
unsigned char EXT_I2C_PWMANA_Num2Adress(unsigned char num);
unsigned char EXT_I2C_PWMANA_SetConfig(unsigned char DIR, unsigned char ONOFF, unsigned char MODE);
unsigned char EXT_I2C_Init_PCA9555_OUT(unsigned char Adress);
unsigned char EXT_I2C_WritePorts_PCA9555(unsigned char Adress, unsigned char port0, unsigned char port1);
unsigned char EXT_I2C_ReadPorts_PCA9555(unsigned char Adress, unsigned char *port0, unsigned char *port1);

void EXT_I2C_Delay10us(unsigned int Time2delay);
#endif
