/* This file has been prepared for Doxygen automatic documentation generation.*/
/*! \file *********************************************************************


TODO: 

 *****************************************************************************/

#include "usart_driver.h"
#include "avr_compiler.h"
#include "clksys_driver.h"
#include "spi_driver.h"
#include "TWI_M_P.h"
#include "CLI.h"
#include <avr\io.h>
#include <stdio.h>

#include "EEP_24FC512.h"
#include "EEP_24FC1025.h"
#include "EXT_I2C.h"
#include "SysTimer.h"
#include "devices.h"
#include "dev_PowerSource.h"
#include "dev_PowerDist.h"



#include "usart_comm.h"

const unsigned char  FlashIdentify[] PROGMEM ="ACAVs railroad control central.  HardVers. 1.0";


int main(void)
{


	//unsigned char test;
    //unsigned char B1[64];
    //unsigned char B2[64];
    //unsigned char po;
    unsigned char result; 
    //struct PacketInfoBlock TPIB;  
       

//******************************** TEST ****************************//


        

//******************************** TEST ****************************//


	
  //*************************************************************//
  //*** PLL with ext. XTAL                                    ***//
  //*************************************************************//
    
  /*  Configure PLL with the XTAL oscillator as source and
  *  multiply by 2 to get 32 MHz PLL clock and enable it. Wait
  *  for it to be stable and set prescaler C to divide by one
  *  to set the CPU clock to 32 MHz. 
  */
  
  
  CLKSYS_XOSC_Config( OSC_FRQRANGE_12TO16_gc, false, OSC_XOSCSEL_XTAL_1KCLK_gc );
  CLKSYS_Enable( OSC_XOSCEN_bm );
  do {} while ( CLKSYS_IsReady( OSC_XOSCRDY_bm ) == 0 );		 
  CLKSYS_PLL_Config( OSC_PLLSRC_XOSC_gc, 2 );     // XTAL Osc is PLL Source, Pll factor is x2
  CLKSYS_Enable( OSC_PLLEN_bm );                  // Enable PLL
  CLKSYS_Prescalers_Config( CLK_PSADIV_1_gc, CLK_PSBCDIV_1_1_gc );// Divide A&C by 1
	
  do {} while ( CLKSYS_IsReady( OSC_PLLRDY_bm ) == 0 );// Wait until ready
  CLKSYS_Main_ClockSource_Select( CLK_SCLKSEL_PLL_gc );// Main clock = PLL
 

  
  /* Enable PMIC interrupt level low. */
  PMIC.CTRL |= PMIC_LOLVLEX_bm;  
  asm("sei;");
  SysTimer_Init();  
  SysTimer_Delay_ms(50);    // delay 500ms 
  //SysTimer_Delay_ms(5);    // delay 500ms
  asm("cli;");	

 
  
  
  //*************************************************************//
  //*** TWI                                                   ***//
  //*************************************************************//
	 
  /* Enable PMIC interrupt level low. */
  PMIC.CTRL |= PMIC_LOLVLEX_bm;

  asm("sei;");

  TWI_MasterInit(0,cnst_TWI_Baudrate_1M);
  EEP_24FC512_Init();
  EEP_24FC1025_Init();
  EXT_I2C_Init();
  
  PowerDist_INIT();

  //*************************************************************//
  //*** USART                                                 ***//
  //*************************************************************//

  
  UARTTimer_Init();
  USART_RS232_InitINT();
  USART_ODCC_InitINTRx();
  USART_BUS485_Init();
  
  USART_RS232_Enable();
  USART_ODCC_Enable();
  
  
  
  /* Enable PMIC interrupt level low. */
  PMIC.CTRL |= PMIC_LOLVLEX_bm;
  
  //*************************************************************//
  //*** Auto detection....                                    ***//
  //*************************************************************//

  SYS_Detected_OpenDCC=1;		// One Open DCC t pos 0 detected :-)
  //SYS_Detected_PowerDist=4;		// to be tested on BUS !

  PowerDist_INIT();
  PowerSource_INIT();



  //*************************************************************//
  //*** Mainloop                                              ***//
  //*************************************************************//
  asm("sei;");
  
  
  while(1)
  {
   asm("nop;");
   
   // New Data packet //
   result=UCOMM_GetNewPacket(&USART_RS232_RxBuf[0],&USART_RS232_TxBuf[0],USART_RS232_GetPacketLen());
   if (result==true)
   {
       CLI_PacketHandler(&USART_RS232_TxBuf[0]);
   }
  
  
  }

}


