


#include "SysTimer.h"
#include <avr\io.h>
#include <avr/interrupt.h>

void SysTimer_Init(void)
{
  TCF0_INTFLAGS|=(1<<0);              // clr OvFl
  TCF0_CNT=SYSTIMER_Reload_10ms;
  TCF0_CTRLA|=(1<<0)+(1<<1)+(1<<2);   // MCK/1024
  TCF0_INTCTRLA=RTC_OVFINTLVL_LO_gc;
  
  MODE_LED_INIT;
  USART_LED_INIT;

}

/**********************************************/
// Delayvalue in 10ms steps !
void SysTimer_Delay_ms(unsigned int Value)
{
    SysTimer_Delay=Value;
    while(SysTimer_Delay);
}

/**********************************************/
void SysTimer_Delay_cylces(unsigned int Value)
{
  // Value MUST be > 34 !
  // so Delay min = ~ 1s @ 32MHz
  TCC1_INTFLAGS|=(1<<0);            // clr OvFl
  TCC1_CNT=(34-Value);
  TCC1_CTRLA|=(1<<0);               // MCK/1
  while(!(TCC1_INTFLAGS & (1<<0))); // wait...
  TCC1_CTRLA=(0);                   // OFF
}
void SysTimer_Delay_cycleslong(unsigned int Value)
{

  TCC1_INTFLAGS|=(1<<0);            // clr OvFl
  TCC1_CNT=(0xFFFF-Value);
  TCC1_CTRLA|=(1<<0);               // MCK/1
  while(!(TCC1_INTFLAGS & (1<<0))); // wait...
  TCC1_CTRLA=(0);                   // OFF
}
/**********************************************/
void SysTimer_TWITO_Start(void)
{
  SysTimer_TWI_TO=SysTimer_TWI_TimeoutTime;
}
/**********************************************/
unsigned char SysTimer_TWITO_Test(void)
{
  if (!SysTimer_TWI_TO) return(0);        // Overflow
  return(1);                              // Not Ovfl
}
/**********************************************/
void SysTimer_TWITO_End(void)
{
  SysTimer_TWI_TO=0;
}

//*************************************************************//
//*** 10ms Timer Overflow INT                               ***//
//*************************************************************//
ISR(TCF0_OVF_vect)
{
    TCF0_CNT=SYSTIMER_Reload_10ms;
    
    if (SysTimer_TWI_TO) SysTimer_TWI_TO--;
    if (SysTimer_LevelMeter) SysTimer_LevelMeter--;
    if (SysTimer_Delay) SysTimer_Delay--;
    if (SysTimer_TaskTimeout) SysTimer_TaskTimeout--;
    if (SysTimer_485_Timeout) SysTimer_485_Timeout--;

    if (USART_LED_Timer)    
    {
        USART_LED_ON;                   // LED ON if timer is > 0
        USART_LED_Timer--;
        
    }
    else
    {
         USART_LED_OFF;                 // LED OFF if timer is 0
    } 
    
    /***************************************************************/
    if (LED_Statusreg & LED_Status_Flag_PING)
    {
        MODE_LED_Timer=MODE_LED_DelayPING;
        LED_Statusreg|=LED_Status_Flag_LEDON;  // set Flag
        MODE_LED_ON;
        LED_Statusreg &=~ LED_Status_Flag_PING;
    }
    /***************************************************************/
    if (MODE_LED_Timer) 
    {
        MODE_LED_Timer--;
    }
    else
    {
        if (LED_Statusreg & LED_Status_Flag_Slow)
        {
         MODE_LED_Timer=MODE_LED_DelaySlow;
        }
        else
        {
         MODE_LED_Timer=MODE_LED_DelayFast;
        }        
        
        if (LED_Statusreg & LED_Status_Flag_LEDON)
        {
            LED_Statusreg&=~LED_Status_Flag_LEDON;  // clr Flag
            MODE_LED_OFF;
        }        
        else
        {
            LED_Statusreg|=LED_Status_Flag_LEDON;  // set Flag
            MODE_LED_ON;
        }
    
    }    

}
