
#include "CLI.h"
#include "usart_comm.h"
#include "dev_powerDist.h"
#include "devices.h"
#include "COMM485.h"
#include "EXT_I2C.h"
#include "EEP_adresses.h"
#include <avr\io.h>
#include <stdio.h>

/* functions use global DIB/PIB for data transfer */
/* functions use I2C-IO to reach Power */
/* functions return Error value as uchar */
/***********************************************************/
/*                                                        */
/***********************************************************/
unsigned char PowerSource_WRITE(unsigned char *TxBuffer)
{
 	unsigned char ret;
    unsigned char Err;
   	unsigned char result;

    
    result=0;
    Err=EXT_I2C_Error_NONE;
    
    ret=EXT_I2C_Write_PWMANA_Power(GlobalPIB.DeviceNum,GlobalPIB.Param_EE,GlobalPIB.Param_FF);   
    if (ret != EXT_I2C_Error_NONE) Err=ret;
    
    
    GlobalPIB.Param_EE=0;

	if (Err!=EXT_I2C_Error_NONE) 
	{
        return(Err);
	}
	else
	{		
		UCOMM_SendAnswerpacket(TxBuffer);
        return(UCOMM_Error_None);			
	}	


}
/***********************************************************/
/*                                                        */
/***********************************************************/
unsigned char PowerSource_READ(unsigned char *TxBuffer)
{
   unsigned char ret;
   unsigned char Err;
    

   Err=EXT_I2C_Error_NONE;
    
   ret=EXT_I2C_Read_PWMANA_Power(GlobalPIB.DeviceNum,GlobalPIB.Param_EE,&GlobalPIB.Param_FF);   
   if (ret != EXT_I2C_Error_NONE) Err=ret;
        
   GlobalPIB.Param_EE=0;

	 if (Err!=EXT_I2C_Error_NONE) 
	 {
        return(Err);
	 }
	 else
	 {		
		UCOMM_SendAnswerpacket(TxBuffer);
    return(UCOMM_Error_None);			
	 }	

}


/***********************************************************/
/*                                                        */
/***********************************************************/
unsigned char PowerSource_SET(unsigned char *TxBuffer)
{
    unsigned char Error;
    
    Error=UCOMM_Error_None;
    UCOMM_SendAnswerpacket_Setup(TxBuffer); // Send Answer
    return(Error);
}    
/***********************************************************/
/*                                                        */
/***********************************************************/
unsigned char PowerSource_GET(unsigned char *TxBuffer)
{
    unsigned char Error;
    unsigned char t8;
    
    Error=UCOMM_Error_None;

    if (SYS_Detected_PowerSourceAn[GlobalPIB.DeviceNum])
    {
        GlobalPIB.Param_EES=EXT_I2C_PWMANA_Num2Adress(GlobalPIB.DeviceNum);
        UCOMM_SendAnswerpacket_Setup(TxBuffer); // Send Answer
    }    
    else
    {
        GlobalPIB.Param_EES=0xFFF;
        Error=UCOMM_Error_DevNumInvalid;       // Send Error
    }    
    return(Error);
}


/***********************************************************/
/*                                                        */
/***********************************************************/
unsigned char PowerSource_INIT(void)
{

	unsigned int Scancnt;
	unsigned char ret,Err;
	
	Err=EXT_I2C_Error_NONE;


    for(Scancnt=0x1;Scancnt<0x9;Scancnt++)
    {
        SYS_Detected_PowerSourceAn[Scancnt]=0;
        Err=EXT_I2C_Read_PWMANA_Power(Scancnt,0,&ret);
        if (Err==EXT_I2C_Error_NONE) SYS_Detected_PowerSourceAn[Scancnt]=1;
    }     


    return(Err);
    
}    
