
#include "CLI.h"
#include "usart_comm.h"
#include "dev_powerDist.h"
#include "devices.h"
#include "COMM485.h"
#include "EXT_I2C.h"
#include "EEP_adresses.h"
#include <avr\io.h>
#include <stdio.h>

/* functions use global DIB/PIB for data transfer */
/* functions return Error value as uchar */


/***********************************************************/
/* Set a signal                                           */
/***********************************************************/
unsigned char SIGNAL_SET(unsigned char *TxBuffer)
{
 	  unsigned char   Err;
   	unsigned char ADR,SNUM;
   	unsigned int  ADR485;
   	unsigned char ret;
   	unsigned char Buffer[16];

    Err=UCOMM_Error_None;

    GlobalPIB.CMD=CLI_PCMD_Signal;
    DEV_4BYTE_GetDIB(GlobalPIB.DeviceNum);     // Get DIB(num)
    
    
    ADR485  = GlobalDIB.RS485adress;
    ADR     = GlobalDIB.SUBadress;
    SNUM    = GlobalDIB.SUBportbit;            // Signalnum 
    Buffer[0]=GlobalPIB.Param_EE;              // Data.....
    
	ret=BUS485_WriteData_Packet(ADR485,&Buffer[0],1,CMD_BUS485_SIGNAL_SET,ADR ,SNUM);
	// BUS485_Error_TimeoutSync, Error or data(0) 
	
    if (ret==BUS485_Error_TimeoutSync)              Err=ret;
	if ((ret==0x10) || (ret > UCOMM_Error_None))    Err=ret;
	
    GlobalPIB.Param_EE=ret;

	if (Err!=UCOMM_Error_None) 
	{
        return(Err);
	}
	else
	{		
		UCOMM_SendAnswerpacket(TxBuffer);
        return(UCOMM_Error_None);			
	}	


}
/***********************************************************/
/* Get a signals value(s)                                 */
/***********************************************************/
unsigned char SIGNAL_GET(unsigned char *TxBuffer)
{
 	  unsigned char Err;
   	unsigned char ADR,SNUM;
   	unsigned int  ADR485;
   	unsigned char ret;
   	unsigned char Buffer[16];

    Err=UCOMM_Error_None;

    GlobalPIB.CMD=CLI_PCMD_Signal;
    DEV_4BYTE_GetDIB(GlobalPIB.DeviceNum);     // Get DIB(num)
    
    
    ADR485  = GlobalDIB.RS485adress;
    ADR     = GlobalDIB.SUBadress;
    SNUM    = GlobalDIB.SUBportbit;
    
	ret=BUS485_ReadData_Packet(ADR485,&Buffer[0],CMD_BUS485_SIGNAL_GET,ADR,SNUM);
	GlobalPIB.Param_EE=Buffer[1];
	
  if (Buffer[0]>0x10) Err=Buffer[0];
  if (ret==BUS485_Error_TimeoutSync)              Err=ret;
	if ((ret==0x10) || (ret > UCOMM_Error_None))    Err=ret;
	

	if (Err!=UCOMM_Error_None) 
	{
        return(Err);
	}
	else
	{		
		UCOMM_SendAnswerpacket(TxBuffer);
        return(UCOMM_Error_None);			
	}	
}

