
#include "CLI.h"
#include "usart_comm.h"
#include "dev_powerDist.h"
#include "devices.h"
#include "COMM485.h"
#include "EXT_I2C.h"
#include "EEP_adresses.h"
#include <avr\io.h>
#include <stdio.h>

/* functions use global DIB/PIB for data transfer */
/* functions return Error value as uchar */


/***********************************************************/
/* Set a signal                                           */
/***********************************************************/
unsigned char Trackswitch_WRITE(unsigned char *TxBuffer)
{
 	unsigned char Err;
   	unsigned char ADR,SPB;
   	unsigned int ADR485;
   	unsigned char ret;
   	unsigned char Buffer[16];
   	unsigned int  CMD;



    Err=UCOMM_Error_None;
    GlobalPIB.CMD=CLI_PCMD_Trackswitch;
    DEV_4BYTE_GetDIB(GlobalPIB.DeviceNum);     // Get DIB(num)
	
    if (GlobalPIB.Param_EE)		CMD=CMD_BUS485_Trackswitch_SETBRANCH;		// set branch if > 0
	if (!GlobalPIB.Param_EE)	CMD=CMD_BUS485_Trackswitch_SETSTRAIGHT;     // set straight if = 0
    
    
    ADR485  = GlobalDIB.RS485adress;
    ADR     = GlobalDIB.SUBadress;
    SPB     = GlobalDIB.SUBportbit;
    
    
	ret=BUS485_WriteData_Packet(ADR485,&Buffer[0],0,CMD,ADR ,SPB);
	// BUS485_Error_TimeoutSync, Error or data(0) 
	
    if ((ret==0x10) || (ret > BUS485_Device_ACK))    Err=ret;
	if ((ret == BUS485_Device_ACK))                  ret=BUS485_Error_None;
    GlobalPIB.Param_EE=ret;

	if (Err!=UCOMM_Error_None) 
	{
        return(Err);
	}
	else
	{		
		UCOMM_SendAnswerpacket(TxBuffer);
        return(UCOMM_Error_None);			
	}	


}
/***********************************************************/
/* Get a signals value(s)                                 */
/***********************************************************/
unsigned char Trackswitch_READ(unsigned char *TxBuffer)
{
 	unsigned char Err;
   	unsigned char ADR,SNUM;
   	unsigned int ADR485;
   	unsigned char ret;
   	unsigned char Buffer[16];

    Err=UCOMM_Error_None;

    GlobalPIB.CMD=CLI_PCMD_Trackswitch;
    DEV_4BYTE_GetDIB(GlobalPIB.DeviceNum);     // Get DIB(num)
    
    
    ADR485  = GlobalDIB.RS485adress;
    ADR     = GlobalDIB.SUBadress;
    SNUM    = GlobalDIB.SUBportbit;
    
	ret=BUS485_ReadData_Packet(ADR485,&Buffer[0],CMD_BUS485_Trackswitch_READ,ADR,SNUM);
	GlobalPIB.Param_EE=Buffer[0];
	
	if ((ret==0x10) || (ret > BUS485_Device_ACK))    Err=ret;
	if ((ret == BUS485_Device_ACK))                  ret=BUS485_Error_None;

	if (Err!=UCOMM_Error_None) 
	{
        return(Err);
	}
	else
	{		
		UCOMM_SendAnswerpacket(TxBuffer);
        return(UCOMM_Error_None);			
	}	
}
