
/**********************************************************************
 *
 *
 *      XMEGA SPI driver source file.
 *****************************************************************************/
#include "spi_driver.h"

void SPI_Master_0_Init(void)
{
  
  // SPI_0_CTRL| = SPI_CLK2X_bm;    // Double Speed
  SPI_0_CTRL |= SPI_ENABLE_bm;      // Enable SPI
  SPI_0_CTRL |= SPI_MASTER_bm;      // Master
  
  // SPI_0_CTRL |=  SPI_PRESCALER0_bm+SPI_PRESCALER1_bm; // Speed = 1/4 if commented
  //** Set Pins to Out/Ins **//

	/* Init SS pin as output with wired AND and pull-up.*/ 
	SPI_0_PORT.DIRSET = PIN4_bm;
	SPI_0_PORT.PIN4CTRL = PORT_OPC_WIREDANDPULL_gc;

	/* Set SS output to high. (No slave addressed). */
	SPI_0_PORT.OUTSET = PIN4_bm;

 	/* MOSI and SCK as output. */
	SPI_0_PORT.DIRSET  = SPI_0_MOSI_bm | SPI_0_SCK_bm;
	SPI_0_CTRL |= SPI_MASTER_bm;      // Master
	
	

}

unsigned char  SPI_Master_0_WriteReadByte(unsigned char data)
{
  SPI_0_DATA = data;
  while(!(SPI_0_STATUS & SPI_IF_bm));
  return(SPI_0_DATA);
}

