
/*  XMEGA SPI driver header file.
 *
 *****************************************************************************/
#ifndef SPI_DRIVER_H
#define SPI_DRIVER_H

#include "avr_compiler.h"

/* Hardware defines */

#define SPI_0_CTRL    SPID_CTRL
#define SPI_0_INTCTRL SPID_INTCTRL
#define SPI_0_STATUS  SPID_STATUS
#define SPI_0_DATA    SPID_DATA
#define SPI_0_PORT    PORTD

#define SPI_0_SS_bm             0x10 /* Bit mask for the SS pin. */
#define SPI_0_MOSI_bm           0x20 /* Bit mask for the MOSI pin. */
#define SPI_0_MISO_bm           0x40 /* Bit mask for the MISO pin. */
#define SPI_0_SCK_bm            0x80 /* Bit mask for the SCK pin. */

void SPI_Master_0_Init(void);
unsigned char  SPI_Master_0_WriteReadByte(unsigned char data);












/* SPI - Serial Peripheral Interface */
/* */
/* SPI.CTRL  bit masks and bit positions */
/* 
#define SPI_CLK2X_bm  0x80    Enable Double Speed bit mask.  
#define SPI_CLK2X_bp  7    Enable Double Speed bit position.  

#define SPI_ENABLE_bm  0x40    Enable Module bit mask.  
#define SPI_ENABLE_bp  6    Enable Module bit position.  

#define SPI_DORD_bm  0x20    Data Order Setting bit mask.  
#define SPI_DORD_bp  5    Data Order Setting bit position.  

#define SPI_MASTER_bm  0x10    Master Operation Enable bit mask.  
#define SPI_MASTER_bp  4    Master Operation Enable bit position.  

#define SPI_MODE_gm  0x0C    SPI Mode group mask.  
#define SPI_MODE_gp  2    SPI Mode group position.  
#define SPI_MODE0_bm  (1<<2)    SPI Mode bit 0 mask.  
#define SPI_MODE0_bp  2    SPI Mode bit 0 position.  
#define SPI_MODE1_bm  (1<<3)    SPI Mode bit 1 mask.  
#define SPI_MODE1_bp  3    SPI Mode bit 1 position.  

#define SPI_PRESCALER_gm  0x03    Prescaler group mask.  
#define SPI_PRESCALER_gp  0    Prescaler group position.  
#define SPI_PRESCALER0_bm  (1<<0)    Prescaler bit 0 mask.  
#define SPI_PRESCALER0_bp  0    Prescaler bit 0 position.  
#define SPI_PRESCALER1_bm  (1<<1)    Prescaler bit 1 mask.  
#define SPI_PRESCALER1_bp  1    Prescaler bit 1 position.  


  SPI.INTCTRL  bit masks and bit positions  
#define SPI_INTLVL_gm  0x03    Interrupt level group mask.  
#define SPI_INTLVL_gp  0    Interrupt level group position.  
#define SPI_INTLVL0_bm  (1<<0)    Interrupt level bit 0 mask.  
#define SPI_INTLVL0_bp  0    Interrupt level bit 0 position.  
#define SPI_INTLVL1_bm  (1<<1)    Interrupt level bit 1 mask.  
#define SPI_INTLVL1_bp  1    Interrupt level bit 1 position.  


  SPI.STATUS  bit masks and bit positions  
#define SPI_IF_bm  0x80    Interrupt Flag bit mask.  
#define SPI_IF_bp  7    Interrupt Flag bit position.  

#define SPI_WRCOL_bm  0x40    Write Collision bit mask.  
#define SPI_WRCOL_bp  6    Write Collision bit position.  

*/

#endif
